#line 1 "F:/MIKROC PROJECTS/IR_DEV_ONOFF1/main.c"


sbit IR_PIN at RC4_bit;
sbit rly1 at RC0_bit;
sbit rly2 at RC1_bit;
sbit rly3 at RC2_bit;
char text[5];
unsigned long ir_code;
unsigned int address;
unsigned short command, inv_command;

short nec_remote_read() {
 unsigned long count = 0, i;

 while ((IR_PIN == 0) && (count <= 180)) {
 count++;
 Delay_us(50);
 }
 if ( (count > 179) || (count < 120))
 return 0;

 count = 0;

 while (IR_PIN && (count <= 90)) {
 count++;
 Delay_us(50);
 }
 if ( (count > 89) || (count < 40))
 return 0;


 for (i = 0; i < 32; i++) {
 count = 0;
 while ((IR_PIN == 0) && (count <= 23)) {
 count++;
 Delay_us(50);
 }
 if ( (count > 22) || (count < 4))
 return 0;

 count = 0;
 while (IR_PIN && (count <= 45)) {
 count++;
 Delay_us(50);
 }
 if ( (count > 44) || (count < 8))
 return 0;

 if ( count > 21)
 ir_code |= 1ul << (31 - i);
 else
 ir_code &= ~(1ul << (31 - i));
 }
 return 1;
}

void main()
{
 ANSEL=0x00;
 CMCON = 0x07 ;
 TRISC = 0b00010000;
 rly1=rly2=rly3=0;
 rly1 = ~rly1;
 Delay_ms(1000);
 rly1 = ~rly1;
 Delay_ms(1000);

 rly1 = ~rly1;
 Delay_ms(1000);
 rly1 = ~rly1;
 Delay_ms(1000);

 rly1 = ~rly1;
 Delay_ms(1000);
 rly1 = ~rly1;
 Delay_ms(1000);

 while (1) {

 while (IR_PIN);
 if (nec_remote_read()) {
 address = ir_code >> 16;
 command = ir_code >> 8;
 inv_command = ir_code;

switch(command) {
#line 114 "F:/MIKROC PROJECTS/IR_DEV_ONOFF1/main.c"
case 0xD8:
rly1 = ~rly1;
Delay_ms(50);
break;
case 0xF8:
Delay_ms(1);
break;
case 0x30:
rly2 = ~rly2;
Delay_ms(50);
break;
case 0xB0:
break;
case 0x70:
rly3 = ~rly3;
Delay_ms(50);
break;
#line 137 "F:/MIKROC PROJECTS/IR_DEV_ONOFF1/main.c"
default:
break;
}}}}
